﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;


using Microsoft.Kinect;
namespace WpfDepthId
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        KinectSensor sensor;
        public MainWindow()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            sensor = KinectSensor.KinectSensors[0];
            sensor.DepthStream.Enable(DepthImageFormat.Resolution320x240Fps30);
            sensor.SkeletonStream.Enable();
            sensor.DepthFrameReady += DepthFrameReady;
            sensor.Start();

        }
        void DepthFrameReady(object sender, DepthImageFrameReadyEventArgs e)
        {
            DepthImageFrame imageFrame = e.OpenDepthImageFrame();
            if (imageFrame != null)
            {
                short[] pixelData = new short[imageFrame.PixelDataLength];
                imageFrame.CopyPixelDataTo(pixelData);
                int[] depth = new int[imageFrame.PixelDataLength];
                int[] player = new int[imageFrame.PixelDataLength];
                int[] playercoded = new int[imageFrame.PixelDataLength];

                for (int i = 0; i < depth.Length; i++)
                {

                    player[i] = pixelData[i] & DepthImageFrame.PlayerIndexBitmask;
                    depth[i] = ((ushort)pixelData[i]) >> DepthImageFrame.PlayerIndexBitmaskWidth;


                    playercoded[i] = 0;
                    if ((player[i] & 0x01) == 0x01)
                        playercoded[i] |= 0xFF0000;
                    if ((player[i] & 0x02) == 0x02)
                        playercoded[i] |= 0x00FF00;
                    if ((player[i] & 0x04) == 0x04)
                        playercoded[i] |= 0x0000FF;
                }

                image1.Source = IntToBitmap(depth, imageFrame.Width, imageFrame.Height);
                image2.Source = IntToBitmap(playercoded, imageFrame.Width, imageFrame.Height);
            }
        }
        BitmapSource IntToBitmap(int[] array, int w, int h)
        {
            BitmapSource bmap = BitmapSource.Create(
                w,
                h,
                96, 96,
                PixelFormats.Bgr32,
                null,
                array,
                w * 4);
            return bmap;

        }


        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            sensor.Stop();
            Environment.Exit(0);
        }
    }
}
